<template>
  <a v-bind="$attrs" type="button" data-bs-toggle="modal" data-bs-target="#doiModal"><slot></slot></a>

  <Teleport to="body">
    <div class="modal fade" id="doiModal" tabindex="-1" aria-labelledby="doiModalLabel" aria-hidden="true">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="doiModalLabel">{{ $t('fetchdoi.modal_title') }}</h5>
            <button ref="close_button" type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
          </div>
          <div class="modal-body">
            <p>
              {{ $t('fetchdoi.modal_text') }}<br/>
              {{ $t('fetchdoi.missing') }}
            </p>
            <div class="input-group has-validation">
              <input ref="input" placeholder="e.g. 10.2218/ijdc.v12i2.578" type="text" id="inputdoi" class="form-control" v-bind:class="{ 'is-invalid' : invalid}">
              <div v-show="invalid" id="validationDoiFeedback" class="invalid-feedback">
                {{ $t('fetchdoi.fetch_error') }}
              </div>
            </div>
          </div>
          <div class="modal-footer">
            <button @click="submit" type="button" class="btn btn-primary">{{ $t('fetchdoi.modal_button') }}</button>
          </div>
        </div>
      </div>
    </div>
  </Teleport>
</template>

<script>
import helper from '../helper'

export default {
  name: 'FetchDoi',
  mixins: [helper],
  data () {
    return {
      invalid: false
    }
  },
  methods: {
    submit () {
      fetch(this.get_api_url() + 'api/fetchdoi/?doi=' + encodeURIComponent(this.$refs.input.value))
        .then(response => {
          if (!response.ok) {
            this.invalid = true
          }
          return response
        }).then(response => response.json())
        .then(data => {
          this.invalid = false
          this.$store.commit('SET_TITLE', data.title)
          this.$store.commit('SET_ABSTRACT', data.abstract)
          this.$store.commit('SET_REFERENCES', data.references)
          this.$refs.close_button.click()
        })
    }
  }
}
</script>
